config/routes.rb
Rails.application.routes.draw do
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # We're not creating a registration.  We're registering.
  get "/register", to: "register_users#new"
  get "/register/registration-complete", to: "register_users#show"
  resource :register, controller: 'register_users', only: [:create]

  # Defines the root path route ("/")
  root "home#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/register.rb
#class Register
#  include ActiveModel::API
#end

app/models/register_user.rb
require "bcrypt"
require "identifier/uuid"

class RegisterUser
  include ActiveModel::API

  attr_accessor :id, :email, :password
  attr_writer :password_hash

  #validates :id#, presence: true
  validates :email,
            format: {
              with: /\A([^@\s]+)@((?:[-a-z0-9]+\.)+[a-z]{2,})\z/i,
              message: "is not an email address"
            }
  validates :password,
            length: { minimum: 8 }#, allow_blank: false

  def self.build
    instance = new

    instance.id = Identifier::UUID::Random.get

    instance
  end

  def password_hash
    @password_hash ||= BCrypt::Password.create(password)
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index
  end
end

app/controllers/register_users_controller.rb
class RegisterUsersController < ApplicationController
  def new
    @register_user = RegisterUser.build
  end

  def create
    @register_user = RegisterUser.new(register_user_params)

    unless @register_user.valid?
      render :new, status: :unprocessable_entity
      return
    end

    # Don't forget to validate the input

    Identity::Client::Register.(
      identity_id: @register_user.id,
      email: @register_user.email,
      password_hash: @register_user.password_hash
    )

    redirect_to "/register/registration-complete" 
  end

  def show
  end

  def register_user_params
    params.require(:register_user).permit(:id, :email, :password)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/register_users_helper.rb
module RegisterUsersHelper
end

app/views/home/index.erb
<h1>This is the home page</h1>

<p>Viewers have watched TODO: ADDME video(s)</p>

<form action="/record-viewing/12345" method="POST">
  <button type="submit">Record viewing video</button>
</form>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Video Tutorials</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
  </head>

  <body>
    <nav class="navbar navbar-expand-lg navbar-light bg-light">
      <a class="navbar-brand" href='#'>Video Tutorials</a>
      <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon" />
      </button>
      <div class="collapse navbar-collapse">
        <ul class="navbar-nav mr-auto">
          <li class="nav-item">
            <a class="nav-link" href="/">Home</a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="/creators-portal">Creator's Portal</a>
          </li>
        </ul>
        <ul class="navbar-nav">
          <li class="nav-item">
            <a class="nav-link" href="/register">Register</a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="/auth/log-in">Log In</a>
          </li>
          <!--
          When we figure out how to tell if the user is logged in:
          if context.userId
            li.nav-item
              a.nav-link(href='/auth/log-out') Log out
          else
            -->
        </ul>
      </div>
    </nav>
    <div class="container">
      <div style="margin-top: 30px">
        <%= yield %>
      </div>
    </div>
    <%= javascript_include_tag "jquery-3.2.1.slim.min" %>
    <%= javascript_include_tag "popper.min" %>
    <%= javascript_include_tag "bootstrap.bundle.min" %>
  </body>
</html>

<!--
  block behavior
  -->

app/views/register_users/new.erb
<h1>Register</h1>

<%= form_with model: @register_user, url: register_path do |form| -%>
  <%= form.hidden_field :id -%>

  <div class="form-group">
    <%= form.label :email -%>
    <%= form.text_field :email, class: "form-control#{@register_user.errors.include?(:email) ? " is-invalid" : ""}", placeholder: "email" -%>
    <% if @register_user.errors.include?(:email) -%>
      <div class="invalid-feedback">
        <%= @register_user.errors.full_messages_for(:email).join(", ") -%>
      </div>
    <% end -%>
  </div>

  <div class="form-group">
    <%= form.label :password -%>
    <%= form.password_field :password, class: "form-control#{@register_user.errors.include?(:password) ? " is-invalid" : "" }", placeholder: "password" -%>
    <% if @register_user.errors.include?(:password) -%>
      <div class="invalid-feedback">
        <%= @register_user.errors.full_messages_for(:password).join(", ") -%>
      </div>
    <% end -%>
  </div>

  <%= form.submit "Register!" -%>
<%- end -%>

app/views/register_users/show.erb
<p class="alert alert-success">
  You have successfully registered!
</p>

<p>Check your email for a link to confirm your email address</p>

<p>
  <a href="/auth/log-in">
    Log in
  </a>
</p>